#!/usr/bin/python
# coding=UTF-8
# These glyphs, and the mapping of file extensions to glyphs has been copied from the vimscript code that is present in https://github.com/ryanoasis/vim-devicons
# Use NerdFonts which can be found here: https://github.com/ryanoasis/nerd-fonts
# import re
# import os

#import os, fnmatch                       # ◄─╮
#files = os.listdir('/home/nnnn/scripts') # ◄─┴── https://stackabuse.com/python-list-files-in-a-directory/

code =         ''
audio =        '' # ♫
video =        '' # 
image =        ''
archive =      ''
text =         ''
excel =        ''
pdf =          ''
font =         ''
android =      ''
address_book = ''
locked =       ''
powerpoint =   ''
executive =    ''
book =         ''
config =       ''

file_node_extensions = {
  '7z'       : archive,
  'a'        : '',
  'ai'       : '',
  'accdb'    : text,
  'apk'      : android,
  'asm'      : '',
  'asp'      : '',
  'aup'      : '',
  'avi'      : video,
  'bat'      : '',
  'bgl'      : book,
  'bmp'      : '',
  'bz2'      : archive,
  'c'        : code,
  'c++'      : code,
  'cab'      : '',
  'cbr'      : '',
  'cbz'      : '',
  'cc'       : '',
  'class'    : '',
  'clj'      : '',
  'cljc'     : '',
  'cljs'     : '',
  'cmake'    : '',
  'coffee'   : '',
  'conf'     : config,
  'cp'       : '',
  'cpio'     : '',
  'cpp'      : '',
  'cs'       : '',
  'css'      : code,
  'cue'      : '',
  'cvs'      : '',
  'cxx'      : '',
  'd'        : '',
  'dart'     : '',
  'db'       : '',
  'deb'      : '',
  'diff'     : '',
  'dll'      : '',
  'dng'      : image,
  'webp'     : image,
  'doc'      : text,
  'docx'     : text,
  'dump'     : '',
  'edn'      : '',
  'efi'      : '',
  'ejs'      : '',
  'elf'      : '',
  'epub'     : book,
  'erl'      : '',
  'exe'      : '',
  'f#'       : '',
  'fifo'     : '|',
  'fish'     : '',
  'flac'     : audio,
  'flv'      : video,
  'fs'       : '',
  'fsi'      : '',
  'fsscript' : '',
  'fsx'      : '',
  'gem'      : '',
  'gif'      : image,
  'go'       : '',
  'gpg'      : locked,
  'gz'       : archive,
  'gzip'     : archive,
  'h'        : '',
  'hbs'      : '',
  'hrl'      : '',
  'hs'       : '',
  'htaccess' : '',
  'htpasswd' : '',
  'htm'      : '',
  'html'     : '',
  'ico'      : '',
  'img'      : '',
  'ini'      : '',
  'iso'      : '',
  'jar'      : '',
  'java'     : '',
  'jl'       : '',
  'jpeg'     : image, #'',
  'jpg'      : image, # '',
  'png'      : image, # '',
  'js'       : code,
  'json'     : code,
  'jsx'      : '',
  'key'      : '',
  'less'     : '',
  'lha'      : '',
  'lhs'      : '',
  'log'      : '',
  'lua'      : '',
  'lzh'      : '',
  'lzma'     : '',
  'm4a'      : audio,
  'm4v'      : video,
  'markdown' : text,
  'md'       : text,
  'mkv'      : video,
  'ml'       : 'λ',
  'mli'      : 'λ',
  'mov'      : video,
  'mp3'      : audio, # '',
  'mp4'      : video, # '',
  'mpeg'     : video,
  'mpg'      : video,
  'msi'      : '',
  'mustache' : '',
  'o'        : '',
  'ogg'      : audio,
  'oga'      : audio,
  'otf'      : font,
  'pdf'      : pdf,
  'php'      : '',
  'pl'       : '',
  'pm'       : '',
  'pub'      : '',
  'ppt'      : powerpoint,
  'pptx'     : powerpoint,
  'psb'      : '',
  'psd'      : '',
  'py'       : '',
  'pyc'      : '',
  'pyd'      : '',
  'pyo'      : '',
  'rar'      : archive,
  'rb'       : '',
  'rc'       : '',
  'rlib'     : '',
  'rom'      : '',
  'rpm'      : '',
  'rs'       : '',
  'rss'      : '',
  'rtf'      : text,
  's'        : '',
  'so'       : '',
  'scala'    : '',
  'scss'     : '',
  'sh'       : '',
  'slim'     : '',
  'sln'      : '',
  'sql'      : '',
  'srt'      : text,
  'styl'     : '',
  'suo'      : '',
  'svg'      : image,
  't'        : '',
  'tar'      : archive,
  'tgz'      : archive,
  'tif'      : image,
  'ts'       : '',
  'ttf'      : font,
  'twig'     : '',
  'txt'      : text,
  'vcf'      : address_book,
  'vim'      : '',
  'vimrc'    : '',
  'wav'      : audio,
  'webm'     : video,
  'xbps'     : '',
  'xhtml'    : '',
  'xls'      : excel,
  'xlsx'     : excel,
  'xml'      : '',
  'xul'      : '',
  'xz'       : archive,
  'yaml'     : '',
  'yml'      : '',
  'zip'      : archive,
}

dir_node_exact_matches = {
#  '.git' : '', # '',
}

file_node_exact_matches = {
#  '.Xauthority'                      : '',
#  '.Xdefaults'                       : '',
#  '.Xresources'                      : '',
#  '.bash_aliases'                    : '',
#  '.bashprofile'                     : '',
#  '.bash_profile'                    : '',
#  '.bash_logout'                     : '',
#  '.bash_history'                    : '',
#  '.bashrc'                          : '',
#  '.dmrc'                            : '',
#  '.DS_Store'                        : '',
#  '.fasd'                            : '',
#  '.fehbg'                           : '',
#  '.gitconfig'                       : '',
#  '.gitattributes'                   : '',
#  '.gitignore'                       : '',
#  '.inputrc'                         : '',
#  '.jack-settings'                   : '',
#  '.mime.types'                      : '',
#  '.nvidia-settings-rc'              : '',
#  '.pam_environment'                 : '',
#  '.profile'                         : '',
#  '.recently-used'                   : '',
#  '.selected_editor'                 : '',
#  '.vim'                             : '',
#  '.vimrc'                           : '',
#  '.viminfo'                         : '',
#  '.xinitrc'                         : '',
#  '.xinputrc'                        : '',
#  'config'                           : '',
#  'dropbox'                          : '',
#  'exact-match-case-sensitive-1.txt' : 'X1',
#  'exact-match-case-sensitive-2'     : 'X2',
#  'favicon.ico'                      : '',
#  'a.out'                            : '',
#  'bspwmrc'                          : '',
#  'sxhkdrc'                          : '',
#  'Makefile'                         : '',
#  'Makefile.in'                      : '',
#  'Makefile.ac'                      : '',
#  'config.mk'                        : '',
#  'config.m4'                        : '',
#  'config.ac'                        : '',
#  'configure'                        : '',
#  'Rakefile'                         : '',
#  'gruntfile.coffee'                 : '',
#  'gruntfile.js'                     : '',
#  'gruntfile.ls'                     : '',
#  'gulpfile.coffee'                  : '',
#  'gulpfile.js'                      : '',
#  'gulpfile.ls'                      : '',
#  'ini'                              : '',
#  'ledger'                           : '',
#  'package.json'                     : '',
#  'package-lock.json'                : '',
#  '.ncmpcpp'                         : '',
#  'playlists'                        : '',
#  'known_hosts'                      : '',
#  'authorized_keys'                  : '',
#  'license'                          : '',
#  'LICENSE.md'                       : '',
#  'LICENSE'                          : '',
#  'LICENSE.txt'                      : '',
#  'mimeapps.list'                    : '',
#  'node_modules'                     : '',
#  'procfile'                         : '',
#  'react.jsx'                        : '',
#  'README.rst'                       : '',
#  'README.md'                        : '',
#  'README.markdown'                  : '',
#  'README'                           : '',
#  'README.txt'                       : '',
#  'user-dirs.dirs'                   : '',
#  'webpack.config.js'                : '',
#  files[0]                           : code,
#  files[1]                           : code,
}

def devicon(file):
  if file.is_directory: return dir_node_exact_matches.get(file.relative_path, '') # ''
  return file_node_exact_matches.get(file.relative_path, file_node_extensions.get(file.extension, '')) # ''
